import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../../../../common";
export type WithdrawRecordStruct = {
    epoch: PromiseOrValue<BigNumberish>;
    shares: PromiseOrValue<BigNumberish>;
};
export type WithdrawRecordStructOutput = [BigNumber, BigNumber] & {
    epoch: BigNumber;
    shares: BigNumber;
};
export interface BatchedWithdrawEpochInterface extends utils.Interface {
    functions: {
        "cancelRedeem()": FunctionFragment;
        "epoch()": FunctionFragment;
        "epochExchangeRate(uint256)": FunctionFragment;
        "epochType()": FunctionFragment;
        "getRequestedShares(address)": FunctionFragment;
        "getWithdrawStatus(address)": FunctionFragment;
        "pendingRedeem()": FunctionFragment;
        "pendingWithdrawU()": FunctionFragment;
        "processRedeem(uint256)": FunctionFragment;
        "redeemIsReady(address)": FunctionFragment;
        "requestRedeem(uint256,address)": FunctionFragment;
        "requestRedeem(uint256)": FunctionFragment;
        "requestedRedeem()": FunctionFragment;
        "withdrawLedger(address)": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "cancelRedeem" | "epoch" | "epochExchangeRate" | "epochType" | "getRequestedShares" | "getWithdrawStatus" | "pendingRedeem" | "pendingWithdrawU" | "processRedeem" | "redeemIsReady" | "requestRedeem(uint256,address)" | "requestRedeem(uint256)" | "requestedRedeem" | "withdrawLedger"): FunctionFragment;
    encodeFunctionData(functionFragment: "cancelRedeem", values?: undefined): string;
    encodeFunctionData(functionFragment: "epoch", values?: undefined): string;
    encodeFunctionData(functionFragment: "epochExchangeRate", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "epochType", values?: undefined): string;
    encodeFunctionData(functionFragment: "getRequestedShares", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "getWithdrawStatus", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "pendingRedeem", values?: undefined): string;
    encodeFunctionData(functionFragment: "pendingWithdrawU", values?: undefined): string;
    encodeFunctionData(functionFragment: "processRedeem", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "redeemIsReady", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "requestRedeem(uint256,address)", values: [PromiseOrValue<BigNumberish>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "requestRedeem(uint256)", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "requestedRedeem", values?: undefined): string;
    encodeFunctionData(functionFragment: "withdrawLedger", values: [PromiseOrValue<string>]): string;
    decodeFunctionResult(functionFragment: "cancelRedeem", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "epoch", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "epochExchangeRate", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "epochType", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getRequestedShares", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getWithdrawStatus", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pendingRedeem", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pendingWithdrawU", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "processRedeem", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "redeemIsReady", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "requestRedeem(uint256,address)", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "requestRedeem(uint256)", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "requestedRedeem", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "withdrawLedger", data: BytesLike): Result;
    events: {
        "ProcessRedeem(uint256,uint256)": EventFragment;
        "RequestWithdraw(address,address,uint256)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "ProcessRedeem"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "RequestWithdraw"): EventFragment;
}
export interface ProcessRedeemEventObject {
    epoch: BigNumber;
    exchangeRate: BigNumber;
}
export type ProcessRedeemEvent = TypedEvent<[
    BigNumber,
    BigNumber
], ProcessRedeemEventObject>;
export type ProcessRedeemEventFilter = TypedEventFilter<ProcessRedeemEvent>;
export interface RequestWithdrawEventObject {
    caller: string;
    owner: string;
    shares: BigNumber;
}
export type RequestWithdrawEvent = TypedEvent<[
    string,
    string,
    BigNumber
], RequestWithdrawEventObject>;
export type RequestWithdrawEventFilter = TypedEventFilter<RequestWithdrawEvent>;
export interface BatchedWithdrawEpoch extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: BatchedWithdrawEpochInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        cancelRedeem(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        epoch(overrides?: CallOverrides): Promise<[BigNumber]>;
        epochExchangeRate(arg0: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[BigNumber]>;
        epochType(overrides?: CallOverrides): Promise<[number]>;
        getRequestedShares(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[BigNumber]>;
        getWithdrawStatus(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[WithdrawRecordStructOutput]>;
        pendingRedeem(overrides?: CallOverrides): Promise<[BigNumber]>;
        pendingWithdrawU(overrides?: CallOverrides): Promise<[BigNumber]>;
        processRedeem(slippageParam: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        redeemIsReady(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        "requestRedeem(uint256,address)"(shares: PromiseOrValue<BigNumberish>, owner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        "requestRedeem(uint256)"(shares: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        requestedRedeem(overrides?: CallOverrides): Promise<[BigNumber]>;
        withdrawLedger(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            epoch: BigNumber;
            shares: BigNumber;
        }>;
    };
    cancelRedeem(overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    epoch(overrides?: CallOverrides): Promise<BigNumber>;
    epochExchangeRate(arg0: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    epochType(overrides?: CallOverrides): Promise<number>;
    getRequestedShares(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
    getWithdrawStatus(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<WithdrawRecordStructOutput>;
    pendingRedeem(overrides?: CallOverrides): Promise<BigNumber>;
    pendingWithdrawU(overrides?: CallOverrides): Promise<BigNumber>;
    processRedeem(slippageParam: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    redeemIsReady(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    "requestRedeem(uint256,address)"(shares: PromiseOrValue<BigNumberish>, owner: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    "requestRedeem(uint256)"(shares: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    requestedRedeem(overrides?: CallOverrides): Promise<BigNumber>;
    withdrawLedger(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[BigNumber, BigNumber] & {
        epoch: BigNumber;
        shares: BigNumber;
    }>;
    callStatic: {
        cancelRedeem(overrides?: CallOverrides): Promise<void>;
        epoch(overrides?: CallOverrides): Promise<BigNumber>;
        epochExchangeRate(arg0: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        epochType(overrides?: CallOverrides): Promise<number>;
        getRequestedShares(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        getWithdrawStatus(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<WithdrawRecordStructOutput>;
        pendingRedeem(overrides?: CallOverrides): Promise<BigNumber>;
        pendingWithdrawU(overrides?: CallOverrides): Promise<BigNumber>;
        processRedeem(slippageParam: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        redeemIsReady(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        "requestRedeem(uint256,address)"(shares: PromiseOrValue<BigNumberish>, owner: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        "requestRedeem(uint256)"(shares: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        requestedRedeem(overrides?: CallOverrides): Promise<BigNumber>;
        withdrawLedger(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            epoch: BigNumber;
            shares: BigNumber;
        }>;
    };
    filters: {
        "ProcessRedeem(uint256,uint256)"(epoch?: null, exchangeRate?: null): ProcessRedeemEventFilter;
        ProcessRedeem(epoch?: null, exchangeRate?: null): ProcessRedeemEventFilter;
        "RequestWithdraw(address,address,uint256)"(caller?: PromiseOrValue<string> | null, owner?: PromiseOrValue<string> | null, shares?: null): RequestWithdrawEventFilter;
        RequestWithdraw(caller?: PromiseOrValue<string> | null, owner?: PromiseOrValue<string> | null, shares?: null): RequestWithdrawEventFilter;
    };
    estimateGas: {
        cancelRedeem(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        epoch(overrides?: CallOverrides): Promise<BigNumber>;
        epochExchangeRate(arg0: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        epochType(overrides?: CallOverrides): Promise<BigNumber>;
        getRequestedShares(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        getWithdrawStatus(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        pendingRedeem(overrides?: CallOverrides): Promise<BigNumber>;
        pendingWithdrawU(overrides?: CallOverrides): Promise<BigNumber>;
        processRedeem(slippageParam: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        redeemIsReady(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        "requestRedeem(uint256,address)"(shares: PromiseOrValue<BigNumberish>, owner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        "requestRedeem(uint256)"(shares: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        requestedRedeem(overrides?: CallOverrides): Promise<BigNumber>;
        withdrawLedger(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        cancelRedeem(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        epoch(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        epochExchangeRate(arg0: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        epochType(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getRequestedShares(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getWithdrawStatus(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        pendingRedeem(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        pendingWithdrawU(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        processRedeem(slippageParam: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        redeemIsReady(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        "requestRedeem(uint256,address)"(shares: PromiseOrValue<BigNumberish>, owner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        "requestRedeem(uint256)"(shares: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        requestedRedeem(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        withdrawLedger(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
